
import os, sys, string, pprint, copy
import serial
import wx
import wx.lib.rcsizer as rcs
from chwin import *
from mixCore import *
from wxPython.wx import *
from wxPython.help import *
from wxPython.lib.anchors import LayoutAnchors
from wxPython.stc import *

bgcolor = ["brown","red","#ff9030","yellow","#30ff20","blue","purple","gray",
           "brown","red","#ff9030","yellow","green","blue","purple","gray"]
fgcolor = ["white","white","white","black","black","white","white","black",
           "white","white","white","black","black","white","white","black"]

pgmwin = NULL
chpanel= []
update = 0

########################################################################
#    CH Control Window                                                 #
########################################################################
class chControlPanel(wx.Panel):
    def __init__(self, parent, com, chctrl, num=0):
        global mixcom
        global chdata
        global bgcolor
        global fgcolor
        global chpanel

        chpanel.append(self)
        chdata = chctrl
        mixcom = com
        wx.Panel.__init__(self, parent, -1, style=wx.RAISED_BORDER)

        self.chnum = num + 1
        chnum = num+1
        chstring = 'Channel%d'%chnum
        chtitle = wx.StaticText(self, -1, chstring)
        chtitle.SetFont(wx.Font(14, wx.DEFAULT, wx.NORMAL, wx.BOLD))
        chtitle.SetBackgroundColour(bgcolor[num])
        chtitle.SetForegroundColour(fgcolor[num])
        chnstr  = 'CH%d Name'%chnum
        self.chname  = wx.TextCtrl(self, -1, chnstr)
        self.chname.SetInsertionPoint(0)
        self.chname.SetSelection(0, 0)
        self.Bind(wx.EVT_TEXT, self.chNameIn, self.chname)

        self.axswin = auxSendPanel(self, num)
        self.tonwin = tonePanel(self, num)
        self.chvwin = chvPanel(self, num)
        self.panwin = panPanel(self, num)

        chsub = wx.BoxSizer(wx.HORIZONTAL)
        chsub.Add(self.tonwin, 0, wx.ALL, 0)
        chsub.Add(self.chvwin, 0, wx.ALL, 0)

        chsizer= wx.BoxSizer(wx.VERTICAL)
        chsizer.Add(chtitle, 0, wx.ALL | wx.EXPAND, 0)
        chsizer.Add(self.chname, 0, wx.ALL | wx.EXPAND, 8)
        chsizer.Add(self.axswin, 0, wx.ALL, 0)
        chsizer.Add(chsub,  0, wx.ALL, 0)
        chsizer.Add(self.panwin, 0, wx.ALL, 0)

        self.SetSizer(chsizer)
        self.SetAutoLayout(True)
        chsizer.Fit(self)

    def chNameIn(self, evt):
        name = self.chname.GetValue()
        chdata.setChName(self.chnum-1, name)

    def setPgmWin(self, win):
        global pgmwin
        pgmwin = win

    def updateAll(self):
        n = self.chnum - 1
        for i in range(4):
            v = 127 - chdata.getChAux(n, i)
            self.axswin.axsnd[i].SetValue(v)
            v = chdata.getChAuxSW(n, i)
            self.axswin.axchk[i].SetValue(v)
            v = chdata.getAuxName(i)
            self.axswin.axtxt[i].SetValue(v)
        for i in range(3):
            v = 127 - chdata.getChTone(n, i)
            self.tonwin.tsld[i].SetValue(v)
        v = 127 - chdata.getChPanpod(n)
        self.panwin.pslide.SetValue(v)
        v = 127 - chdata.getChVol(n)
        self.chvwin.vslide.SetValue(v)
        v = chdata.getChMute(n)
        self.chvwin.vchk.SetValue(v)
        v = chdata.getChName(n)
        self.chname.SetValue(v)

#----------------------------------------------------------------------#
#    Aux Send control panel                                            #
#----------------------------------------------------------------------#
class auxSendPanel(wx.Panel):
    def __init__(self, parent, num=99):
        wx.Panel.__init__(self, parent, -1, style=wx.RAISED_BORDER)
        self.chtop = parent
        step = 16
        self.chnum = num
        auxTitle = wx.StaticText(self, -1, "Aux Send Level")
        auxTitle.SetFont(wx.Font(11, wx.DEFAULT, wx.NORMAL, wx.BOLD))
        auxTitle.SetForegroundColour("#006000")

        #### Aux Settings ####
        self.axsnd = []
        self.axchk = []
        self.axtxt = []
        axbox = []
        axlbl = ['AUX1', 'AUX2', 'AUX3', 'AUX4']
        axevhnd = [self.aux1Slider, self.aux2Slider,
                    self.aux3Slider, self.aux4Slider]
        axckhnd = [self.aux1Chk, self.aux2Chk, self.aux3Chk, self.aux4Chk]
        axtxthnd= [self.ax1Text, self.ax2Text, self.ax3Text, self.ax4Text]
        for i in range(4) :
            v = 127 - chdata.getChAux(self.chnum, i)
            win = wx.Slider(self, -1, v, 0, 127, size=(30, 60),
                       style=wx.SL_VERTICAL | wx.SL_AUTOTICKS | wx.SL_LEFT,
                       name=axlbl[i])
            win.SetTickFreq(step)
            self.axsnd.append(win)
            txt = wx.TextCtrl(self, -1, axlbl[i], size=(48,14),
                              style=wx.TE_CENTER)
            self.axtxt.append(txt)
            lbl = wx.CheckBox(self, -1, "Mute", style=wx.CHK_2STATE)
            v = chdata.getChAuxSW(self.chnum, i)
            lbl.SetValue(v);
            self.axchk.append(lbl)
            box = wx.BoxSizer(wx.VERTICAL)
            box.Add(self.axsnd[i], 0, wx.ALL | wx.ALIGN_CENTER, 4)
            box.Add(self.axchk[i], 0, wx.ALL | wx.ALIGN_CENTER, 0)
            box.Add(self.axtxt[i], 0, wx.ALL | wx.ALIGN_CENTER, 5)
            box.Fit(self)
            axbox.append(box)
            self.Bind(wx.EVT_SCROLL, axevhnd[i], self.axsnd[i])
            self.Bind(wx.EVT_CHECKBOX, axckhnd[i], self.axchk[i])
            self.Bind(wx.EVT_TEXT, axtxthnd[i], self.axtxt[i])

        # a 10 pixel border around each
        #axsub = wx.GridBagSizer(2, 2)
        axsub = rcs.RowColSizer()
        axsub.Add(axbox[0], row=0, col=0, flag=wx.EXPAND)
        axsub.Add(axbox[1], row=0, col=1, flag=wx.EXPAND)
        axsub.Add(axbox[2], row=1, col=0, flag=wx.EXPAND)
        axsub.Add(axbox[3], row=1, col=1, flag=wx.EXPAND)
        axwin = wx.BoxSizer(wx.VERTICAL)
        axwin.Add(auxTitle, 0, wx.ALL, 0)
        axwin.Add(axsub, 0, wx.ALL, 0)

        self.SetSizer(axwin)
        self.SetAutoLayout(True)
        axwin.Fit(self)

    def ax1Text(self, evt):
        global chpanel
        global update
        if update == 1:
            return False
        update = 1
        name = self.axtxt[0].GetValue()
        chdata.setAuxName(self.chnum, 0, name)
        for i in range(16):
            chpanel[i].axswin.axtxt[0].SetValue(name)
        update = 0

    def ax2Text(self, evt):
        global chpanel
        global update
        if update == 1:
            return False
        update = 1
        name = self.axtxt[1].GetValue()
        chdata.setAuxName(self.chnum, 1, name)
        for i in range(16):
            chpanel[i].axswin.axtxt[1].SetValue(name)
        update = 0

    def ax3Text(self, evt):
        global chpanel
        global update
        if update == 1:
            return False
        update = 1
        name = self.axtxt[2].GetValue()
        chdata.setAuxName(self.chnum, 2, name)
        for i in range(16):
            chpanel[i].axswin.axtxt[2].SetValue(name)
        update = 0

    def ax4Text(self, evt):
        global chpanel
        global update
        if update == 1:
            return False
        update = 1
        name = self.axtxt[3].GetValue()
        chdata.setAuxName(self.chnum, 3, name)
        for i in range(16):
            chpanel[i].axswin.axtxt[3].SetValue(name)
        update = 0

    def aux1Slider(self, evt):
        """AUX1 Slider process."""
        value = 127 - self.axsnd[0].GetValue()
        chdata.setAuxSnd(self.chnum, 0, value)
        pgmwin.differValue()

    def aux2Slider(self, evt):
        """AUX2 Slider process."""
        value = 127 - self.axsnd[1].GetValue()
        chdata.setAuxSnd(self.chnum, 1, value)
        pgmwin.differValue()

    def aux3Slider(self, evt):
        """AUX3 Slider process."""
        value = 127 - self.axsnd[2].GetValue()
        chdata.setAuxSnd(self.chnum, 2, value)
        pgmwin.differValue()

    def aux4Slider(self, evt):
        """AUX4 Slider process."""
        value = 127 - self.axsnd[3].GetValue()
        chdata.setAuxSnd(self.chnum, 3, value)
        pgmwin.differValue()

    def aux1Chk(self, evt):
        """AUX1 Mute Check box process"""
        value = self.axchk[0].GetValue()
        chdata.setAuxSndSw(self.chnum, 0, value)
        pgmwin.differValue()

    def aux2Chk(self, evt):
        """AUX2 Mute Check box process"""
        value = self.axchk[1].GetValue()
        chdata.setAuxSndSw(self.chnum, 1, value)
        pgmwin.differValue()

    def aux3Chk(self, evt):
        """AUX3 Mute Check box process"""
        value = self.axchk[2].GetValue()
        chdata.setAuxSndSw(self.chnum, 2, value)
        pgmwin.differValue()

    def aux4Chk(self, evt):
        """AUX4 Mute Check box process"""
        value = self.axchk[3].GetValue()
        chdata.setAuxSndSw(self.chnum, 3, value)
        pgmwin.differValue()

    def auxSetVolume(self, new, axnum):
        self.axsnd[axnum].SetValue(127 - new)

    def auxSetMute(self, new, ch, axnum):
        if new == 0:
            self.axchk[axnum].SetValue(False)
        else:
            self.axchk[axnum].SetValue(True)


#----------------------------------------------------------------------#
#    Equalizer Control Panel                                           #
#----------------------------------------------------------------------#
class tonePanel(wx.Panel):
    def __init__(self, parent, num=99):
        wx.Panel.__init__(self, parent, -1, style=wx.RAISED_BORDER)

        # Now create the Panel to put the other controls on.
        # axpnl = wx.Panel(self, style=wx.SIMPLE_BORDER) #
        step = 16
        width = 30
        height= 58
        self.chnum = num
        tlbl = ['High', 'Mid', 'Low']
        tnevhnd = [self.toneHSlider, self.toneMSlider, self.toneLSlider]
        tncehnd = [self.HiCenter, self.MidCenter, self.LowCenter]
        self.tsld = []
        tbox = []

        #### Tone control Label ####
        toneTitle = wx.StaticText(self, -1, "Tone")
        toneTitle.SetFont(wx.Font(11, wx.DEFAULT, wx.NORMAL, wx.BOLD))
        toneTitle.SetForegroundColour("#600000")

        #### Tone control ####
        for i in range(3) :
            v = 127 - chdata.getChTone(self.chnum, i)
            win = wx.Slider(self, -1, v, 0, 127, size=(width, height),
                       style=wx.SL_VERTICAL | wx.SL_AUTOTICKS | wx.SL_LEFT,
                       name=tlbl[i])
            win.SetTickFreq(step)
            self.tsld.append(win)
            txt = wx.Button(self, -1, tlbl[i], size=(36, 15))
            txt.SetFont(wx.Font(7, wx.DEFAULT, wx.NORMAL, wx.NORMAL))
            self.Bind(wx.EVT_BUTTON, tncehnd[i], txt)
            box = wx.BoxSizer(wx.VERTICAL)
            box.Add(self.tsld[i], 0, wx.ALIGN_CENTER, 0)
            box.Add(txt, 0, wx.ALIGN_CENTER, 0)
            tbox.append(box)
            self.Bind(wx.EVT_SCROLL, tnevhnd[i], self.tsld[i])

        tonesub = wx.BoxSizer(wx.VERTICAL)
        for i in range(3) :
            tonesub.Add(tbox[i], 0, wx.ALL, 0)

        tonewin = wx.BoxSizer(wx.VERTICAL)
        tonewin.Add(toneTitle, 0, wx.ALL, 0)
        tonewin.Add(tonesub, 0, wx.ALL, 0)
        self.SetSizer(tonewin)
        self.SetAutoLayout(True)
        tonewin.Fit(self)

    def HiCenter(self, evt):
        self.tsld[0].SetValue(63)
        chdata.setHigh(self.chnum, 63)
        pgmwin.differValue()

    def MidCenter(self, evt):
        self.tsld[1].SetValue(63)
        chdata.setMid(self.chnum, 63)
        pgmwin.differValue()

    def LowCenter(self, evt):
        self.tsld[2].SetValue(63)
        chdata.setLow(self.chnum, 63)
        pgmwin.differValue()

    def toneHSlider(self, evt):
        """Tone High Slider process."""
        value = 127 - self.tsld[0].GetValue()
        chdata.setHigh(self.chnum, value)
        pgmwin.differValue()

    def toneMSlider(self, evt):
        """Tone Mid Slider process."""
        value = 127 - self.tsld[1].GetValue()
        chdata.setMid(self.chnum, value)
        pgmwin.differValue()

    def toneLSlider(self, evt):
        """Tone Low Slider process."""
        value = 127 - self.tsld[2].GetValue()
        chdata.setLow(self.chnum, value)
        pgmwin.differValue()

    def setToneVolume(self, new, ch, tnum):
        self.tsld[tnum].SetValue(127 - new)

#----------------------------------------------------------------------#
#    Channel main volume panel                                         #
#----------------------------------------------------------------------#
class chvPanel(wx.Panel):
    def __init__(self, parent, num=99):
        wx.Panel.__init__(self, parent, -1,
                          style=wx.RAISED_BORDER, size=(120, 240))
        self.chnum = num

        #### title ####
        vTitle = wx.StaticText(self, -1, "Volume")
        vTitle.SetFont(wx.Font(11, wx.DEFAULT, wx.NORMAL, wx.BOLD))
        vTitle.SetForegroundColour("#000060")
        step = 4

        #### slider ####
        v = 127 - chdata.getChVol(self.chnum)
        vspnl  = wx.Panel(self, size=(20, 180))
        self.vslide = wx.Slider(self, -1, v, 0, 127, size=(53, 207),
                       style=wx.SL_VERTICAL | wx.SL_AUTOTICKS | wx.SL_LEFT |
                       wx.SL_RIGHT | wx.ALIGN_CENTER_VERTICAL,
                       name="CH")
        self.vslide.SetTickFreq(step)
        self.Bind(wx.EVT_SCROLL, self.chVolSlider, self.vslide)
        vsbox = wx.BoxSizer(wx.HORIZONTAL)
        vsbox.Add(vspnl, 0, wx.ALL, 0)
        vsbox.Add(self.vslide, 0, wx.ALL, 0)

        #### mute button ####
        self.vchk = wx.CheckBox(self, -1, "Mute", style=wx.CHK_2STATE)
        self.vchk.SetValue(False)
        self.Bind(wx.EVT_CHECKBOX, self.chVolMute, self.vchk)

        #### layout ####
        vbox = wx.BoxSizer(wx.VERTICAL)
        vbox.Add(vTitle, 0, wx.ALIGN_CENTER, 0)
        vbox.Add(vsbox,  0, wx.ALIGN_CENTER, 0)
        vbox.Add(self.vchk,   0, wx.ALIGN_CENTER, 8)

        self.SetSizer(vbox)
        self.SetAutoLayout(True)
        vbox.Fit(self)

    def chVolSlider(self, evt) :
        """CH Volume Slider process."""
        value = 127 - self.vslide.GetValue()
        chdata.setChVol(self.chnum, value)
        pgmwin.differValue()

    def setChVol(self, new, ch):
        self.vslide.SetValue(127 - new)

    def chVolMute(self, evt):
        """CH Mute Check box process"""
        value = self.vchk.GetValue()
        if value == 1:
            chdata.setChVol(self.chnum, -1)	# Mute on
        else:
            chdata.setChVol(self.chnum, -2)	# Mute off
        pgmwin.differValue()

    def setChMute(self, new, ch):
        if new == 0:
            self.vchk.SetValue(False)
        else:
            self.vchk.SetValue(True)
        # end

#----------------------------------------------------------------------#
#    Panpod Control Panel                                              #
#----------------------------------------------------------------------#
class panPanel(wx.Panel):
    def __init__(self, parent, num):
        wx.Panel.__init__(self, parent, -1, style=wx.RAISED_BORDER)

        step = 8
        self.chnum = num
        panTitle = wx.StaticText(self, -1, "Panpod")
        panTitle.SetFont(wx.Font(11, wx.DEFAULT, wx.NORMAL, wx.BOLD))
        panTitle.SetForegroundColour("#600060")
        self.pcenter = wx.Button(self, -1, " C ", size=(30,16))
        self.Bind(wx.EVT_BUTTON, self.panCenter, self.pcenter)
        ptitle = wx.BoxSizer(wx.HORIZONTAL)
        ptitle.Add(panTitle, 0, wx.LEFT, 4)
        ptitle.Add(self.pcenter, 0, wx.LEFT, 20)
        ptitle.Fit(self)

        v = 127 - chdata.getChPanpod(self.chnum)
        self.pslide = wx.Slider(self, -1, v, 0, 127, size=(116, 30),
                       style=wx.SL_HORIZONTAL | wx.SL_AUTOTICKS | wx.SL_LEFT,
                       name="PAN")
        self.pslide.SetTickFreq(step)
        self.Bind(wx.EVT_SCROLL, self.panSlider, self.pslide)
        panwin = wx.BoxSizer(wx.VERTICAL)
        panwin.Add(ptitle, 0, wx.ALL, 0)
        panwin.Add(self.pslide, 0, wx.ALL, 0)
        self.SetSizer(panwin)
        self.SetAutoLayout(True)
        panwin.Fit(self)

    def panCenter(self, evt):
        value = 63
        self.pslide.SetValue(63)
        chdata.setPan(self.chnum, 63)
        pgmwin.differValue()

    def panSlider(self, evt):
        """Panpod Slider process."""
        value = 127 - self.pslide.GetValue()
        chdata.setPan(self.chnum, value)
        pgmwin.differValue()
