#----------------------------------------------------------------------
# A very simple wxPython example.  Just a wxFrame, wxPanel,
# wxStaticText, wxButton, and a wxBoxSizer, but it shows the basic
# structure of any wxPython application.
#----------------------------------------------------------------------
import os, sys, string, pprint, copy
import serial
import wx
from pgwin import *
from wxPython.wx import *
from wxPython.help import *
from wxPython.lib.anchors import LayoutAnchors
from wxPython.stc import *

#----------------------------------------------------------------------#
#    description of mixer control parameter                            #
#----------------------------------------------------------------------#
#### System information ####
LCH = 1
RCH = 2
MAX_AXR  = 127
MAX_MAIN = 127
baudrate = 38400
connect  = False

#### Main data information ####
mnvl = [0, 0]
mainmut = 0
phone   = [65, 65]
auxrtn  = [[65, 65], [65, 65], [65, 65], [65, 65]]
axname = []

#### Ch data information ####
chname = []
chvl   = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
chmut   = [ 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0]
panpod  = [63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63]
axsv =  [
    [65, 65, 65, 65], [65, 65, 65, 65], [65, 65, 65, 65], [65, 65, 65, 65],
    [65, 65, 65, 65], [65, 65, 65, 65], [65, 65, 65, 65], [65, 65, 65, 65],
    [65, 65, 65, 65], [65, 65, 65, 65], [65, 65, 65, 65], [65, 65, 65, 65],
    [65, 65, 65, 65], [65, 65, 65, 65], [65, 65, 65, 65], [65, 65, 65, 65],
]
axsw =  [
    [0, 0, 0, 0], [0, 0, 0, 0], [0, 0, 0, 0], [0, 0, 0, 0],
    [0, 0, 0, 0], [0, 0, 0, 0], [0, 0, 0, 0], [0, 0, 0, 0],
    [0, 0, 0, 0], [0, 0, 0, 0], [0, 0, 0, 0], [0, 0, 0, 0],
    [0, 0, 0, 0], [0, 0, 0, 0], [0, 0, 0, 0], [0, 0, 0, 0],
]
tone = [
    [64, 64, 64], [64, 64, 64], [64, 64, 64], [64, 64, 64],
    [64, 64, 64], [64, 64, 64], [64, 64, 64], [64, 64, 64],
    [64, 64, 64], [64, 64, 64], [64, 64, 64], [64, 64, 64],
    [64, 64, 64], [64, 64, 64], [64, 64, 64], [64, 64, 64],
]

#### Program information ####
pgmnum = 0
pgname = chr(0)
pgdate = [0, 0, 0, 0, 0, 0]

#### MIDI information ####

#### system information ####
comport = 0
mnlock = 0
chlock = 0
comSet = [
    [38400, 1, 8, 0], [38400, 1, 8, 0], [38400, 1, 8, 0], [38400, 1, 8, 0]
]
beepSet = [4000, 32, 1]
contrast = 20
stamode = 0
defch = 0

#----------------------------------------------------------------------#
#    definition of command                                             #
#----------------------------------------------------------------------#
#### ch data recieve command ####
C_CHDREQ   = '\x10'
C_CHDSEND  = '\x11'
C_CHSEND   = '\x12'

#### main data send/recieve command ####
C_MNDREQ   = '\x20'
C_MNDSEND  = '\x21'
C_MNSEND   = '\x22'

#### system information send/recieve command ####
C_PGM      = '\x30'
C_PGMNAME  = '\x31'
C_PGMDATE  = '\x32'
C_LOCK     = '\x33'
C_PGMEND   = '\x88'
C_PINGOUT  = '\xaa'
C_PINGIN   = '\xa5'

C_SYSREQ   = '\x40'
C_SYSSET   = '\x41'

class sysCtrl:
    def __init__(self):
        global syscore
        syscore = self
        self.update = 0

    def __del__(self):
        return True

    def getComData(self, ch):
        global comSet
        return comSet[ch]

    def getBps(self, ch):
        global comSet
        return comSet[ch][0]

    def setBps(self, b, ch):
        global comSet
        if comSet[ch][0] != b:
            self.update = 1
            comSet[ch][0] = b
        #end setBps

    def getStop(self, ch):
        global comSet
        return comSet[ch][1]

    def setStop(self, s, ch):
        global comSet
        if comSet[ch][1] != s:
            self.update = 1
            comSet[ch][1] = s
        #end setStop

    def getDatalen(self, ch):
        global comSet
        return comSet[ch][2]

    def setDatalen(self, l, ch):
        global comSet
        if comSet[ch][2] != l:
            self.update = 1
            comSet[ch][2] = l
        #end setStop

    def getParity(self, ch):
        global comSet
        return comSet[ch][3]

    def setParity(self, p, ch):
        global comSet
        if comSet[ch][3] != p:
            self.update = 1
            comSet[ch][3] = p
        #end setparity

    def getComPort(self):
        return comport

    def getBeep(self):
        global beepSet
        return beepSet

    def getBeepFreq(self):
        global beepSet
        return beepSet[0]

    def setBeepFreq(self, f):
        global beepSet
        if f != beepSet[0]:
            self.update = 1
            beepSet[0] = f

    def getBeepLen(self):
        global beepSet
        return beepSet[1]

    def setBeepLen(self, l):
        global beepSet
        if l != beepSet[1]:
            self.update = 1
            beepSet[1] = l

    def getBeepEn(self):
        global beepSet
        return beepSet[2]

    def setBeeEn(self, en):
        global beepSet
        if l != beepSet[2]:
            self.update = 1
            beepSet[2] = l

    def getContrast(self):
        return contrast

    def setContrast(self, c):
        global contrast
        if c != contrast:
            self.update = 1
            contrast = c

    def getStartMode(self):
        return stamode

    def setStartMode(self, sm):
        global stamode
        if sm != stamode:
            self.update = 1
            stamode = sm

    def getDefaultCh(self):
        return defch

    def setDefaultCh(self, dc):
        global defch
        if dc != defch:
            self.update = 1
            defch = dc

    def beepTest(self, bf, bl, be):
        global mixcom
        mixcom.beepTest(bf, bl, be)

    def testContrast(self, ct):
        mixcom.testContrast(ct)

    def progSysEnv(self, flag):
        if flag == 1:
            if self.update == 1:
                mixcom.progSysEnv()
        else:
            mixcom.cancelSysEnv()

#----------------------------------------------------------------------#
#    Main volume class(Main, Phone, AUX return)                        #
#    Main data(Mainvol, Phonevol, AUX return) interface                #
#----------------------------------------------------------------------#
class mainCtrl:
    def __init__(self):
        global    mndata
        mndata = self

    def __del__(self):
        return True

    def setMain(self, lr, data):
        global mnvl
        global mainmut
        upd = 0
        if (lr & LCH) != 0:			# LCH
            if data[0] == -1:
                if (mainmut & 0x01) == 0:
                    mainmut = mainmut | 0x01	# Mute on
                    upd = 1
            elif data[0] == -2:
                if (mainmut & 0x01) != 0:
                    mainmut = mainmut & 0xfe	# Mute off
                    upd = 1
            else:
                if mnvl[0] != data[0]:
                    mnvl[0] = data[0]		# volume set
                    upd = 1
        if (lr & RCH) != 0:			# RCH
            if data[1] == -1:
                if (mainmut & 0x02) == 0:
                    mainmut = mainmut | 0x02	# Mute on
                    upd = 1
            elif data[1] == -2:
                if (mainmut & 0x02) != 0:
                    mainmut = mainmut & 0xfd	# Mute off
                    upd = 1
            else:
                if mnvl[1] != data[1]:
                    mnvl[1] = data[1]		# data set
                    upd = 1
        if upd != 0:
            mixcom.mainVolOut()			# out to Mixer
    #end outMain

    #### phone volume ####
    def setPhone(self, lr, data):
        global phone
        upd = 0
        if (lr & LCH) != 0:			# LCH
            if phone[0] != data[0]:
                phone[0] = data[0]		# volume set
                upd = 1
        if (lr & RCH) != 0:			# RCH
            if phone[1] != data[1]:
                phone[1] = data[1]		# data set
                upd = 1
        if upd != 0:
            mixcom.phoneVolOut()                # out to Mixer
    #end setPhone

    #### AUX Return control ####
    def setAuxRtn(self, ch, lr, data):
        global auxrtn
        upd = 0
        if (lr & LCH) != 0:
            if auxrtn[ch][0] != data[0]:
                auxrtn[ch][0] = data[0]		# volume set
                upd = 1
        if (lr & RCH) != 0:
            if auxrtn[ch][1] != data[1]:
                auxrtn[ch][1] = data[1]		# volume set
                upd = 1
        if upd != 0:
            mixcom.auxrOut(ch)                  # out to Mixer
    #end setAuxRtn

    #### Pgm load ####
    def setPgmLoad(self, pgn):
        global pgmnum
        pgmnum = pgn
        rtn = mixcom.pgmLoad(pgmnum)
        return rtn

    #### Pgm save ####
    def setPgmSave(self, pno, pname, date):
        global pgmnum
        pgmnum = pno
        if pname == "":
            return False
        if len(pname) > 16:
            name = pname[0:15]
        else:
            name = pname
        mixcom.pgmSetNumber(pno)
        mixcom.pgmSetName(pname)
        mixcom.checkAck()
        mixcom.pgmSetDate(date)
        mixcom.checkAck()
        mixcom.mainDataOut()
        mixcom.checkAck()
        for i in range(4):
            mixcom.auxNameOut(i)
            mixcom.checkAck()
        for i in range(16):
            mixcom.chDataOut(i)
            mixcom.checkAck()
            mixcom.chNameOut(i, chname[i])
            mixcom.checkAck()
        mixcom.pgmSavePgm()

    #### query data function ####
    def getmain(self):
        global mnvl
        return mnvl
    def getmainL(self):
        global mnvl
        return mnvl[0]
    def getmainR(self):
        global mnvl
        return mnvl[1]
    def checkMainMute(self):
        global mainmut
        return mainmut
    def getphone(self):
        global phone
        return phone
    def getphoneL(self):
        global phone
        return phone[0]
    def getphoneR(self):
        global phone
        return phone[1]
    def getAuxRtnL(self, ch):
        global auxrtn
        return auxrtn[ch][0]
    def getAuxRtnR(self, ch):
        global auxrtn
        return auxrtn[ch][1]
    def getPgmNum(self):
        global pgmnum
        return pgmnum
    def getPgmName(self):
        global pgname
        return pgname
    def getPgmDate(self):
        global pgdate
        return pgdate
    def getMnLock(self):
        global mnlock
        return mnlock
    def getChLock(self):
        global chlock
        return chlock
    def getAuxName(self, axno):
        global axname
        return axname[axno]

#end mainCtrl

#----------------------------------------------------------------------#
#    ch data class                                                     #
#    ch data interface                                                 #
#----------------------------------------------------------------------#
class chCtrl:
    def __init__(self):
        global chdata
        chdata = self

    def __del__(self):
        return True

    #### ch volume ####
    def setChVol(self, ch, data):
        global chvl
        global chmut
        upd = 0
        if data == -1:
            chmut[ch] = 1		# Mute on
        elif data == -2:
            chmut[ch] = 0		# Mute off
        else:
            chvl[ch] = data		# volume set
        mixcom.chVolOut(ch, chmut[ch])	# out to Mixer
    #end setChVol

    #### AUX Send ####
    def setAuxSnd(self, ch, auxch, data):
        global axsv
        global axsw
        upd = 0
        if data == -1:
            if axsw[ch][auxch] == 0:
                axsw[ch][auxch] = 1	# AUX send on
                upd = 1
        elif data == -2:
            if axsw[ch][auxch] == 1:
                axsw[ch][auxch] = 0	# AUX send off
                upd = 1
        else:
            if axsv[ch][auxch] != data:
                axsv[ch][auxch] = data	# volume set
                upd = 1
        if upd != 0:
            mixcom.chAuxOut(ch, auxch)
    #end setAuxSnd

    #### AUX Send Switch ####
    def setAuxSndSw(self, ch, auxch, data):
        global axsv
        global axsw
        upd = 0
        if data == 0:
            axsw[ch][auxch] = 0		# AUX send off
            upd = 1
        else:
            axsw[ch][auxch] = 1		# AUX send on
            upd = 1
        if upd != 0:
            mixcom.chAuxOut(ch, auxch)
    #end setAuxSndSw

    #### set panpod ####
    def setPan(self, ch, data):
        global panpod
        if panpod[ch] != data:
            panpod[ch] = data
            mixcom.chToneOut(ch, 3)
    #end setPan

    #### set tone ####
    def setHigh(self, ch, data):
        global tone
        if tone[ch][0] != data:
            tone[ch][0] = data
            mixcom.chToneOut(ch, 0)
    def setMid(self, ch, data):
        global tone
        if tone[ch][1] != data:
            tone[ch][1] = data
            mixcom.chToneOut(ch, 1)
    def setLow(self, ch, data):
        global tone
        if tone[ch][2] != data:
            tone[ch][2] = data
            mixcom.chToneOut(ch, 2)

    #### Set Aux name ####
    def setAuxName(self, ch, axno, name):
        global axname
        nlen = len(name)
        axname[axno] = ''
        for i in range(nlen):
            axname[axno] = axname[axno] + chr(ord(name[i]))

    #### Set CH name ####
    def setChName(self, ch, name):
        global chname
        nlen = len(name)
        chname[ch] = ''
        for i in range(nlen):
            chname[ch] = chname[ch] + chr(ord(name[i]))

    #### get channel data ####
    def getChVol(self, ch):
        global chvl
        return chvl[ch]

    def getChMute(self, ch):
        global chmut
        return chmut[ch]

    def getChAux(self, ch, axch):
        global axsv
        return axsv[ch][axch]

    def getChAuxSW(self, ch, axch):
        global axsw
        return axsw[ch][axch]

    def getChTone(self, ch, tonenum):
        global tone
        return tone[ch][tonenum]

    def getChPanpod(self, ch):
        global panpod
        return panpod[ch]

    def getChName(self, ch):
        global chanme
        return chname[ch]

    def getAuxName(self, axno):
        global axname
        return axname[axno]

#end chCtrl

class mixerConnectCheck(wx.Timer):
    def __init__(self):
        global chkctrl
        chkctrl = self
        wx.Timer.__init__(self)		# initialize timer
        self.cnt = 0
        self.Start(400)			# timer notify/400msec
        mixcom.checkOK = True

    def Notify(self):
        apply(self.execCheckConnect, ())

    def execCheckConnect(self):
        global mixcom
        self.cnt = self.cnt + 1
        if self.cnt > 3:
            self.cnt = 0
            mixcom.checkConnect()

    def resetCheckCounter(self):
        self.cnt = 0

#class checkConnect

#----------------------------------------------------------------------#
#    mixerCom class                                                    #
#    communication with mixer                                          #
#----------------------------------------------------------------------#
class mixerCom:
    def __init__(self):
        global initpgm
        global mixcom			# define global object
        global mnwinok
        global axname
        global chname
        mixcom = self                   # self object open
        initpgm = 0
        mnwinok = 0
        self.lock = 0
        for i in range(4):
            name = 'AUX%d'%(i+1)
            axname.append(name)
        for i in range(16):
            name = 'Channel%02d'%(i+1)
            chname.append(name)
        try:
            self.ser = serial.Serial(comport,
                                     baudrate,
                                     8,
                                     serial.PARITY_NONE,
                                     serial.STOPBITS_ONE,
                                     timeout=0,
                                     xonxoff=0, rtscts=0)
        except:
            print 'Error: COM%d open error'%(comport+1)
            self.startDialog = 'COM error'
            self.open = False
        else:
            self.startDialog = 'OK'
            self.open = True
            self.checkOK  = False
            self.runcheck = True		# run check flag initialize
            self.connect  = False		# connect status initialize
            self.checkConnect()			# connect flag initialize
            if self.connect == True:
                self.setDefaultFromMixer()
        #end try
    #end __init__

    def __del__(self):
        self.ser.flushOutput()
        self.ser.close()
        #self.__del__()

    def checkConnect(self):
        global initpgm
        if self.open == False:
            return True
        if self.runcheck == False:
            return True
        data = C_PINGOUT
        self.ser.write(data)
        dlen = 0
        timeout = 0
        while dlen < 1:
            dlen = self.ser.inWaiting()
            timeout = timeout + 1
            if timeout > 0x3fff:
                self.connect = False
                if initpgm == 1:
                    pgwin.connect.SetLabel(connstr)
                    pgwin.connect.SetForegroundColour(conncol)
                return False
        data = self.ser.read(1)
        if initpgm == 1:
            pgwin.connect.SetLabel(constr)
            pgwin.connect.SetForegroundColour(concol)
        if self.connect == False:
            self.Lock()
            self.mainDataIn()
            for i in range(16):
                self.chDataIn(i)
        self.connect = True
        return True

    def setConWin(self, win, str, nstr, col, ncol):
        global pgwin
        global constr
        global connstr
        global concol
        global conncol
        global initpgm

        initpgm = 1
        pgwin = win
        constr = str
        connstr= nstr
        concol = col
        conncol= ncol

    def resetCheckInterval(self):
        self.runcheck = False

    def setCheckInterval(self):
        if self.checkOK == True:
            chkctrl.resetCheckCounter()
        self.runcheck = True

    def setDefaultFromMixer(self):
        self.getPgmInfo()
        self.mainDataIn()
        for i in range(16):
            self.chDataIn(i)
            self.chNameIn(i)
        for i in range(4):
            self.AuxNameIn(i)
            self.getComData(i)
        self.getSysData()
        # pgm Data in

    #------------------------------------------------------------------#
    #        data out ot Mixer                                         #
    #------------------------------------------------------------------#
    def commandOut(self, cmd, data):
        self.ser.write(cmd)
        self.ser.flushOutput()
        for i in range(0x1fff):
            dummy = i
        for c in data:
            self.ser.write(c)
            self.ser.flushOutput()
            for i in range(0x1fff):
                dummy = i

    #### Main volume and mute ####
    def mainDataOut(self):
        global mnvl
        global auxrtn
        global phone
        global mainmut
        self.resetCheckInterval()
        data = chr(mnvl[0]) + chr(mnvl[1])
        data = data + chr(auxrtn[0][0]) + chr(auxrtn[0][1])
        data = data + chr(auxrtn[1][0]) + chr(auxrtn[1][1])
        data = data + chr(auxrtn[2][0]) + chr(auxrtn[2][1])
        data = data + chr(auxrtn[3][0]) + chr(auxrtn[3][1])
        data = data + chr(phone[0]) + chr(phone[1]) + chr(mainmut)
        self.commandOut(C_MNDSEND, data)
        self.setCheckInterval()

    def mainVolOut(self):
        self.resetCheckInterval()
        data = 'V' + chr(mnvl[0]) + chr(mnvl[1]) + chr(mainmut)
        self.commandOut(C_MNSEND, data)
        self.setCheckInterval()


    def phoneVolOut(self):
        self.resetCheckInterval()
        data = 'P' + chr(phone[0]) + chr(phone[1]) + chr(0)
        self.commandOut(C_MNSEND, data)
        self.setCheckInterval()

    def auxNameOut(self, axno):
        self.resetCheckInterval()
        nlen = len(axname[axno])
        data = 'A' + chr(axno)
        for i in range(nlen):
            data = data + axname[axno][i]
        for i in range(16-nlen):
            data = data + chr(0)
        self.commandOut(C_PGMNAME, data)
        self.setCheckInterval()

    #### Aux return ####
    def auxrOut(self, ch):
        self.resetCheckInterval()
        if ch == 0:
            data = 'A'+chr(auxrtn[0][0])+chr(auxrtn[0][1])+chr(0)
        elif ch == 1:
            data = 'B'+chr(auxrtn[1][0])+chr(auxrtn[1][1])+chr(0)
        elif ch == 2:
            data = 'C'+chr(auxrtn[2][0])+chr(auxrtn[2][1])+chr(0)
        elif ch == 3:
            data = 'D'+chr(auxrtn[3][0])+chr(auxrtn[3][1])+chr(0)
        self.commandOut(C_MNSEND, data)
        self.setCheckInterval()

    #### ch data all out ####
    def chDataOut(self, ch):
        global axsv
        global chvl
        global tone
        global panpod
        global chmut
        global sndsw
        self.resetCheckInterval()
        sndsw = 0
        if axsw[ch][0] == 1:
            sndsw = sndsw | 0x01
        if axsw[ch][1] == 1:
            sndsw = sndsw | 0x02
        if axsw[ch][2] == 1:
            sndsw = sndsw | 0x04
        if axsw[ch][3] == 1:
            sndsw = sndsw | 0x08
        data = chr(ch) + chr(chvl[ch]) + chr(axsv[ch][0]) + chr(axsv[ch][1])
        data = data + chr(axsv[ch][2]) + chr(axsv[ch][3]) + chr(tone[ch][0])
        data = data + chr(tone[ch][1]) + chr(tone[ch][2]) + chr(panpod[ch])
        data = data + chr(chmut[ch]) + chr(sndsw)
        self.commandOut(C_CHDSEND, data)
        self.setCheckInterval()

    #### ch volume/mute data ####
    def chVolOut(self, ch, mut):
        self.resetCheckInterval()
        if mut == 1:
            data = 'V' + chr(ch) + chr(chvl[ch]) + chr(1)
        else:
            data = 'V' + chr(ch) + chr(chvl[ch]) + chr(0)
        self.commandOut(C_CHSEND, data)
        self.setCheckInterval()

    #### CH Name out ####
    def chNameOut(self, chno, name):
        self.resetCheckInterval()
        nlen = len(name)
        data = 'C' + chr(chno)
        for i in range(nlen):
            data = data + name[i]
        for i in range(16-nlen):
            data = data + chr(0)
        self.commandOut(C_PGMNAME, data)
        self.setCheckInterval()

    #### AUX send volume/mute ####
    def chAuxOut(self, ch, auxch):
        self.resetCheckInterval()
        if auxch == 0:
            data = 'A' + chr(ch) + chr(axsv[ch][0]) + chr(axsw[ch][0])
        elif auxch == 1:
            data = 'B' + chr(ch) + chr(axsv[ch][1]) + chr(axsw[ch][1])
        elif auxch == 2:
            data = 'C' + chr(ch) + chr(axsv[ch][2]) + chr(axsw[ch][2])
        else:
            data = 'D' + chr(ch) + chr(axsv[ch][3]) + chr(axsw[ch][3])
        self.commandOut(C_CHSEND, data)
        self.setCheckInterval()

    #### tone/pan ####
    def chToneOut(self, ch, tnum):
        self.resetCheckInterval()
        if (tnum == 0):
            data = 'H' + chr(ch) + chr(tone[ch][0]) + chr(0)
        elif (tnum == 1):
            data = 'M' + chr(ch) + chr(tone[ch][1]) + chr(0)
        elif (tnum == 2):
            data = 'L' + chr(ch) + chr(tone[ch][2]) + chr(0)
        elif (tnum == 3):
            data = 'P' + chr(ch) + chr(panpod[ch]) + chr(0)
        self.commandOut(C_CHSEND, data)
        self.setCheckInterval()

    #### panel lock() ####
    def Lock(self):
        global mnlock
        global chlock
        self.resetCheckInterval()
        if mnlock == 0:
            mnlock = 1
            mflg = '\x01'
        else:
            mnlock = 0
            mflg = '\x00'
        if chlock == 0:
            chlock = 1
            cflg = '\x01'
        else:
            chlock = 0
            cflg = '\x00'
        data = mflg + cflg
        self.commandOut(C_LOCK, data)
        self.setCheckInterval()

    def mnLock(self):
        global mnlock
        global chlock
        self.resetCheckInterval()
        if mnlock == 0:
            mnlock = 1
            mflg = '\x01'
        else:
            mnlock = 0
            mflg = '\x00'
        cflg = chr(chlock)
        data = mflg + cflg
        self.commandOut(C_LOCK, data)
        self.setCheckInterval()

    def chLock(self):
        global mnlock
        global chlock
        self.resetCheckInterval()
        if chlock == 0:
            chlock = 1
            cflg = '\x01'
        else:
            chlock = 0
            cflg = '\x00'
        mflg = chr(mnlock)
        data = mflg + cflg
        self.commandOut(C_LOCK, data)
        self.setCheckInterval()

    #### Program Change ####
    def pgmLoad(self, num):
        global pgname
        global pgdate
        self.resetCheckInterval()
        data = 'L' + chr(num)
        self.commandOut(C_PGM, data)
        dlen = 0
        timeout = 0
        while dlen < 23:
            dlen = self.ser.inWaiting()
            timeout = timeout + 1
            if timeout > 0xfffff:
                break
        if timeout > 0xfffff:
            pgname = chr(0)
            pgdate = [0, 0, 0, 0, 0, 0]
            return False
        data = self.ser.read(23)
        if ord(data[0]) != 0x89:
            return False
        if ord(data[1]) == 0xff:
            return False
        pgname = data[1:17]
        pgdate = [2000+ord(data[17]), ord(data[18]), ord(data[19]),
                  ord(data[20]), ord(data[21]), ord(data[22])]
        if pgdate[1] > 12:	pgdate[1] = 0
        if pgdate[2] > 31:	pgdate[2] = 0
        if pgdate[3] > 24:	pgdate[3] = 0
        if pgdate[4] > 60:	pgdate[4] = 0
        if pgdate[5] > 60:	pgdate[5] = 0
        self.mainDataIn()
        for i in range(16):
            self.chDataIn(i)
            self.chNameIn(i)
        for i in range(4):
            self.AuxNameIn(i)
        self.setCheckInterval()
        return True

    def pgmSetNumber(self, pno):
        self.resetCheckInterval()
        data = 'I' + chr(pno)
        self.commandOut(C_PGM, data)
        self.setCheckInterval()

    def pgmSetName(self, name):
        self.resetCheckInterval()
        nlen = len(name)
        data = 'P' + chr(0)
        for i in range(nlen):				# byte size$BJQ49(B
            data = data + chr(ord(name[i]))
        for i in range(16-nlen):
            data = data + chr(0)
        self.commandOut(C_PGMNAME, data)
        self.setCheckInterval()

    def pgmSetDate(self, d):
        self.resetCheckInterval()
        data = chr(d[0])+chr(d[1])+chr(d[2])+chr(d[3])  # $BG/7nF|MK(B
        data = data + chr(d[4])+chr(d[5])+chr(d[6])	# $B;~J,IC(B
        self.commandOut(C_PGMDATE, data)
        self.setCheckInterval()

    def pgmSavePgm(self):
        self.resetCheckInterval()
        data = 'S' + chr(0)
        self.commandOut(C_PGM, data)        
        dlen = 0
        while dlen < 1:
            dlen = self.ser.inWaiting()
        data = self.ser.read(1)
        self.setCheckInterval()
        if ord(data[0]) == 0x88:
            self.setCheckInterval()
            return True
        else:
            self.setCheckInterval()
            return False
        #end checkAck

    def getPgmInfo(self):
        global pgmnum
        global pgname
        global pgdate

        self.resetCheckInterval()
        data = 'Q' + '\x00'
        self.commandOut(C_PGM, data)
        dlen = 0
        while dlen < 3:
            dlen = self.ser.inWaiting()
        data = self.ser.read(3)
        if ord(data[0]) != 0x82:
            self.setCheckInterval()
            return False
        if ord(data[1]) == 0:
            self.setCheckInterval()
            return False
        pgmnum = ord(data[1])
        data = 'V' + chr(pgmnum)
        self.commandOut(C_PGM, data)
        dlen = 0
        timeout = 0
        while dlen < 23:
            dlen = self.ser.inWaiting()
            timeout = timeout + 1
            if timeout > 0xfffff:
                break
        if timeout > 0xfffff:
            pgname = chr(0)
            pgdate = [0, 0, 0, 0, 0, 0]
            self.setCheckInterval()
            return False
        data = self.ser.read(23)
        if ord(data[0]) != 0x89:
            self.setCheckInterval()
            return False
        if ord(data[1]) == 0xff:
            self.setCheckInterval()
            return False
        pgname = data[1:17]
        pgdate = [2000+ord(data[17]), ord(data[18]), ord(data[19]),
                  ord(data[20]), ord(data[21]), ord(data[22])]
        if pgdate[1] > 12:	pgdate[1] = 0
        if pgdate[2] > 31:	pgdate[2] = 0
        if pgdate[3] > 24:	pgdate[3] = 0
        if pgdate[4] > 60:	pgdate[4] = 0
        if pgdate[5] > 60:	pgdate[5] = 0
        self.setCheckInterval()
        return True
        
    def checkAck(self):
        self.resetCheckInterval()
        dlen = 0
        while dlen < 1:
            dlen = self.ser.inWaiting()
        data = self.ser.read(1)
        if ord(data[0]) == 0x55:
            self.setCheckInterval()
            return True
        else:
            self.setCheckInterval()
            return False
        #end checkAck
    #------------------------------------------------------------------#
    #        input data from Mixer                                     #
    #------------------------------------------------------------------#
    def setMainWin(self, win):
        global mnwin
        global mnwinok
        mnwin = win
        mnwinok = 1

    def mainDataIn(self):
        global mnwin
        global mnwinok
        self.resetCheckInterval()
        data = 'D' + chr(0)
        self.commandOut(C_MNDREQ, data)
        dlen = 0
        while dlen < 14:
            dlen = self.ser.inWaiting()
        data = self.ser.read(14)
        mnvl[0]      = ord(data[1])
        mnvl[1]      = ord(data[2])
        auxrtn[0][0] = ord(data[3])
        auxrtn[0][1] = ord(data[4])
        auxrtn[1][0] = ord(data[5])
        auxrtn[1][1] = ord(data[6])
        auxrtn[2][0] = ord(data[7])
        auxrtn[2][1] = ord(data[8])
        auxrtn[3][0] = ord(data[9])
        auxrtn[3][1] = ord(data[10])
        phone[0]     = ord(data[11])
        phone[1]     = ord(data[12])
        mainmut      = ord(data[13])
        self.setCheckInterval()

    def AuxNameIn(self, axno):
        global axname
        self.resetCheckInterval()
        data = 'N' + chr(axno)
        self.commandOut(C_MNDREQ, data)
        dlen = 0
        while dlen < 17:
            dlen = self.ser.inWaiting()
        data = self.ser.read(17)
        if ord(data[0]) != 0x83:	return False
        name = data[1:16]
	axname[axno] = name

    def chDataIn(self, ch):
        self.resetCheckInterval()
        data = 'D' + chr(ch)
        self.commandOut(C_CHDREQ, data)
        dlen = 0
        while dlen < 13:
            dlen = self.ser.inWaiting()
        data = self.ser.read(13)
        chvl[ch] = ord(data[2])		# ch volume
        axsv[ch][0] = ord(data[3])	# aux1 send
        axsv[ch][1] = ord(data[4])	# aux2 send
        axsv[ch][2] = ord(data[5])	# aux3 send
        axsv[ch][3] = ord(data[6])	# aux4 send
        tone[ch][0] = ord(data[7])	# tone high
        tone[ch][1] = ord(data[8])	# tone mid
        tone[ch][2] = ord(data[9])	# tone low
        panpod[ch]  = ord(data[10])	# panpod
        chmut[ch]   = ord(data[11])	# CH mute
        flag = ord(data[12])
        if (flag & 0x01):		# aux1 send switch
            axsw[ch][0] = 0
        else:
            axsw[ch][0] = 1
        if (flag & 0x02):		# aux2 send switch
            axsw[ch][1] = 0
        else:
            axsw[ch][1] = 1
        if (flag & 0x04):		# aux3 send switch
            axsw[ch][2] = 0
        else:
            axsw[ch][2] = 1
        if (flag & 0x08):		# aux4 send switch
            axsw[ch][3] = 0
        else:
            axsw[ch][3] = 1
        self.setCheckInterval()

    def chNameIn(self, chno):
        global chname
        self.resetCheckInterval()
        data = 'N' + chr(chno)
        self.commandOut(C_CHDREQ, data)
        dlen = 0
        while dlen < 17:
            dlen = self.ser.inWaiting()
        data = self.ser.read(17)
        if ord(data[0]) != 0x83:
            self.setCheckInterval()
            return False
        name = data[1:16]
	chname[chno] = name
        self.setCheckInterval()
        return True

    def getComData(self, chno):
        global comSet
        self.resetCheckInterval()
        data = 'C' + chr(chno)
        self.commandOut(C_SYSREQ, data)
        dlen = 0
        while dlen < 10:
            dlen = self.ser.inWaiting()
        data = self.ser.read(10)
        if ord(data[0]) != 0x8a:
            self.setCheckInterval()
            return False
        comSet[chno][0] = (ord(data[3]) << 8 + ord(data[4])) * 10
        comSet[chno][1] = ord(data[5])			# Stop Bit
        comSet[chno][2] = ord(data[6])			# data length
        comSet[chno][3] = ord(data[7])			# Parity
        self.setCheckInterval()
        return True

    def getSysData(self):
        global beepSet
        global contrast
        global stamode
        global defch

        self.resetCheckInterval()
        data = 'B' + chr(0)
        self.commandOut(C_SYSREQ, data)
        dlen = 0
        while dlen < 10:
            dlen = self.ser.inWaiting()
        data = self.ser.read(10)
        if ord(data[0]) != 0x8a:
            self.setCheckInterval()
            return False
        beepSet[0] = ord(data[2])*256 + ord(data[3])	# Beep Frequency
        beepSet[1] = ord(data[4])*256 + ord(data[5])	# Beep length
        beepSet[2] = ord(data[6])			# Beep enable
        stamode = ord(data[7])				# Start mode
        contrast = ord(data[8]) / 4			# contrast
        defch = ord(data[9])				# default ch
        self.setCheckInterval()
        return True

    def beepTest(self, bf, bl, be):
        self.resetCheckInterval()
        data = 'b' +  chr((bf&0xff00)>>8) + chr(bf&0x00ff)
        data = data + chr((bl&0xff00)>>8) + chr(bl&0x00ff)
        data = data + chr(be) + '\xff' + '\xff'
        self.commandOut(C_SYSSET, data)
        self.setCheckInterval()
        return True

    def testContrast(self, ct):
        self.resetCheckInterval()
        data = 'c' + '\xff' + '\xff' + '\xff' + '\xff' + '\xff' + '\xff'
        data = data + chr(ct*4)
        self.commandOut(C_SYSSET, data)
        self.setCheckInterval()
        return True

    def progSysEnv(self):
        global comSet
        global beepSet
        global contrast
        global stamode
        global defch
        self.resetCheckInterval()
        for i in range(4):
            data = 'C' + chr(i)
            data = data + chr((comSet[i][0]/10) >> 8)
            data = data + chr((comSet[i][0]/10) & 0x00ff)
            data = data + chr(comSet[i][1]) + chr(comSet[i][2])
            data = data + chr(comSet[i][3]) + '\xff'
            self.commandOut(C_SYSSET, data)
            self.checkAck()
        data = 'B' + chr(beepSet[0] >> 8) + chr(beepSet[0] & 0x00ff)
        data = data + chr(beepSet[1] >> 8) + chr(beepSet[1] & 0x00ff)
        data = data + chr(beepSet[2])
        data = data + chr(stamode) + chr(contrast*4)
        self.commandOut(C_SYSSET, data)
        self.checkAck()
        data = 'D' + chr(defch) + '\xff'+'\xff'+'\xff'+'\xff'+'\xff'+'\xff'
        self.commandOut(C_SYSSET, data)
        self.checkAck()
        data = 'P' + '\xff'+'\xff'+'\xff'+'\xff'+'\xff'+'\xff'+'\xff'
        self.commandOut(C_SYSSET, data)
        dlen = 0
        while dlen < 1:
            dlen = self.ser.inWaiting()
        data = self.ser.read(1)
        if ord(data[0]) == 0x88:
            self.setCheckInterval()
            return True
        else:
            self.setCheckInterval()
            return False
        #end progSysEnv()

    def cancelSysEnv(self):
        self.resetCheckInterval()
        data = 'N' + '\xff'+'\xff'+'\xff'+'\xff'+'\xff'+'\xff'+'\xff'
        self.commandOut(C_SYSSET, data)
        self.setCheckInterval()

# end of file #
