#----------------------------------------------------------------------
# A very simple wxPython example.  Just a wxFrame, wxPanel,
# wxStaticText, wxButton, and a wxBoxSizer, but it shows the basic
# structure of any wxPython application.
#----------------------------------------------------------------------
import os, sys, string, pprint, copy
import serial
import wx
from mixCore import *
from pgwin import *
from titlewin import *
from wxPython.wx import *
from wxPython.help import *
from wxPython.lib.anchors import LayoutAnchors
from wxPython.stc import *

MAX_MAIN = 127
MAX_AUX  = 127
########################################################################
#    $B%a%$%s%3%s%H%m!<%k%Q%M%k(B                                          #
########################################################################
class mainControlPanel(wx.Panel):
    def __init__(self, parent, mixcore, mnctrl, chwindow):
        global mainPanel
        global chvwin
        global comctrl
        global mndata

        comctrl = mixcore
        mndata = mnctrl
        wx.Panel.__init__(self, parent, -1, style=wx.RAISED_BORDER)
        mainPanel = self
        comctrl = mixcore
        comctrl.setMainWin(self)

        #### Volume Control Area ####
        # AUX Return $B%Q%M%k@8@.(B #
        axrTitle = wx.StaticText(self, -1, "Aux Return")
        axrTitle.SetFont(wx.Font(14, wx.DEFAULT, wx.NORMAL, wx.BOLD))
        axrTitle.SetForegroundColour("blue")
        self.axrwin = []
        self.axrwin.append(auxReturnPanel(self, "Aux1", 0))
        self.axrwin.append(auxReturnPanel(self, "Aux2", 1))
        self.axrwin.append(auxReturnPanel(self, "Aux3", 2))
        self.axrwin.append(auxReturnPanel(self, "Aux4", 3))

        # $B%a%$%s%\%j%e!<%`%Q%M%k(B #
        mvTitle = wx.StaticText(self, -1, "Main Level")
        mvTitle.SetFont(wx.Font(14, wx.DEFAULT, wx.NORMAL, wx.BOLD))
        mvTitle.SetForegroundColour("blue")
        self.mvwin = mainVolumePanel(self, "MainVolume")

        # GridBagSizer #
        self.gbs = wx.GridBagSizer(3, 3)
        self.gbs.Add(axrTitle,     (0, 0), span=(1, 2), flag=wx.LEFT, border=4)
        self.gbs.Add(mvTitle,      (0, 2), span=(1, 1), flag=wx.LEFT, border=4)
        self.gbs.Add(self.axrwin[0], (1, 0), span=(1, 1))
        self.gbs.Add(self.axrwin[1], (1, 1), span=(1, 1))
        self.gbs.Add(self.axrwin[2], (2, 0), span=(1, 1))
        self.gbs.Add(self.axrwin[3], (2, 1), span=(1, 1))
        self.gbs.Add(self.mvwin,   (1, 2), span=(2, 1))

        #### Title Area ####
        self.titlewin = titlePanel(self, "Kmixer-1602")

        #### Program Chnage panel ####
        self.pgwin = pgmSettingPanel(self, comctrl, mndata, chwindow)

        #### $B%Q%M%kA4BND4@0(B ####
        mnwin = wx.BoxSizer(wx.VERTICAL)
        mnwin.Add(self.titlewin, 0, wx.ALL, 0)
        mnwin.Add(self.pgwin, 0, wx.TOP, 6)
        mnwin.Add(self.gbs, 0, wx.TOP, 10)

        self.SetSizer(mnwin)
        self.SetAutoLayout(True)
        mnwin.Layout()
        mnwin.Fit(self)
        gbsize = self.gbs.GetSize()
        pgsize = self.pgwin.GetSize()
        winsize = (gbsize.width, pgsize.height)
        self.pgwin.SetSize(winsize)
        self.winsize = self.GetSize()
        wsize = (self.winsize.width, self.titlewin.winsize.height)
        self.titlewin.SetSize(wsize)

    def updateAll(self):
        for i in range(4):
            v = 127 - mndata.getAuxRtnL(i)
            self.axrwin[i].axrL.SetValue(v)        
            v = 127 - mndata.getAuxRtnR(i)
            self.axrwin[i].axrR.SetValue(v)
        v = 127 - mndata.getmainL()
        self.mvwin.mvL.SetValue(v)
        v = 127 - mndata.getmainR()
        self.mvwin.mvR.SetValue(v)

########################################################################
#    AUX Return $B%Q%M%k(B                                                 #
########################################################################
class auxReturnPanel(wx.Panel):
    def __init__(self, parent, title, anum):
        global mnwin
        wx.Panel.__init__(self, parent, -1, style=wx.RAISED_BORDER)

        mnwin = parent
        step = 8
        self.axnum = anum
        axrTitle = wx.StaticText(self, -1, title)

        #### Aux Return Left ####
        v = 127 - auxrtn[anum][0]
        self.axrL = wx.Slider(self, -1, v, 0, 127, size=(32, 114),
                       style=wx.SL_VERTICAL | wx.SL_AUTOTICKS | wx.SL_LEFT,
                       name="AuxrL")
        self.axrL.SetTickFreq(step)
        self.Bind(wx.EVT_SCROLL, self.axrtnLSlider, self.axrL)
        axrLlbl = wx.StaticText(self, -1, ' Left')
        axrLlbl.SetFont(wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.NORMAL))
        axrLbox = wx.BoxSizer(wx.VERTICAL)
        axrLbox.Add(self.axrL, 0, wx.ALL, 0)
        axrLbox.Add(axrLlbl, 0, wx.ALL, 0)

        #### Aux Return Right ####
        v = 127 - auxrtn[anum][1]
        self.axrR = wx.Slider(self, -1, v, 0, 127, size=(32, 114),
                       style=wx.SL_VERTICAL | wx.SL_AUTOTICKS | wx.SL_LEFT,
                       name="AuxrR")
        self.axrR.SetTickFreq(step)
        self.Bind(wx.EVT_SCROLL, self.axrtnRSlider, self.axrR)
        axrRlbl = wx.StaticText(self, -1, ' Right')
        axrRlbl.SetFont(wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.NORMAL))
        axrRbox = wx.BoxSizer(wx.VERTICAL)
        axrRbox.Add(self.axrR, 0, wx.ALL, 0)
        axrRbox.Add(axrRlbl, 0, wx.ALL, 0)

        #### Slider Layout ####
        axrsizer = wx.BoxSizer(wx.HORIZONTAL)
        axrsizer.Add(axrLbox, 0, wx.ALL, 0)
        axrsizer.Add(axrRbox, 0, wx.ALL, 0)

        #### Sync button ####
        self.axbtn = wx.CheckBox(self, -1, "Sync", style=wx.CHK_2STATE)
        self.axbtn.SetValue(1)

        #### Layout ####
        axrwin = wx.BoxSizer(wx.VERTICAL)
        axrwin.Add(axrTitle, 0, wx.ALL, 0)
        axrwin.Add(axrsizer, 0, wx.ALL, 0)
        axrwin.Add(self.axbtn, 0, wx.ALL, 4)
        self.SetSizer(axrwin)
        self.SetAutoLayout(True)
        axrwin.Fit(self)

    def axrtnLSlider(self, evt):
        """AUX Return Slider process."""
        n = self.axnum
        vm = []
        sync = self.axbtn.GetValue()
        vm.append(127 - self.axrL.GetValue())
        vm.append(127 - self.axrR.GetValue())
        sub = mndata.getAuxRtnL(n) - vm[0]
        if sync == True :
            vm[1] = vm[1] - sub
            if vm[1] > MAX_AUX:
                vm[1] = MAX_AUX
            elif vm[1] < 0:
                vm[1] = 0
            self.axrR.SetValue(127 - vm[1])
            mndata.setAuxRtn(n, 3, vm)
        else:
            mndata.setAuxRtn(n, 1, vm)
        mnwin.pgwin.differValue()
        # def axrtnLSlider() end

    def axrtnRSlider(self, evt):
        """AUX Return Slider process."""
        n = self.axnum
        vm = []
        sync = self.axbtn.GetValue()
        vm.append(127 - self.axrL.GetValue())
        vm.append(127 - self.axrR.GetValue())
        sub = mndata.getAuxRtnR(n) - vm[1]
        if sync == True :
            vm[0] = vm[0] - sub
            if vm[0] > MAX_AUX:
                vm[0] = MAX_AUX
            elif vm[0] < 0:
                vm[0] = 0
            self.axrL.SetValue(127 - vm[0])
            mndata.setAuxRtn(n, 3, vm)
        else:
            mndata.setAuxRtn(n, 2, vm)
        mnwin.pgwin.differValue()
        # def axrtnLSlider end

########################################################################
#    $B%a%$%s%\%j%e!<%`(B($B%X%C%I%U%)%s%\%j%e!<%`IU$-(B)                      #
########################################################################
class mainVolumePanel(wx.Panel):
    def __init__(self, parent, title):
        global mnwin
        wx.Panel.__init__(self, parent, -1, style=wx.RAISED_BORDER)

        mnwin = parent
        step = 4
        #### $B%^!<%+!<%9%i%$%@(B ####
        self.mark = wx.Slider(self, -1, 64, 0, 127, size=(20, 240),
                        style=wx.SL_VERTICAL | wx.SL_AUTOTICKS | wx.SL_RIGHT,
                         name="MainVolumeL")
        self.mark.SetTickFreq(step)
        mklbl = wx.StaticText(self, -1, "")
        mklbl.SetFont(wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.NORMAL))
        mkbox = wx.BoxSizer(wx.VERTICAL)
        mkbox.Add(self.mark,  0, wx.ALL, 0)
        mkbox.Add(mklbl, 0, wx.ALL, 0)
        
        #### $B%a%$%s%\%j%e!<%`(B L ####
        v = 127 - mndata.getmainL()
        self.mvL =wx.Slider(self, -1, v, 0, 127, size=(40, 238),
                        style=wx.SL_VERTICAL | wx.SL_AUTOTICKS | wx.SL_LEFT |
                        wx.SL_RIGHT | wx.ALIGN_CENTER_VERTICAL,
                         name="MainVolumeL")
        self.mvL.SetTickFreq(step)
        self.Bind(wx.EVT_SCROLL, self.mainLSlider, self.mvL)
        self.mtlbtn = wx.CheckBox(self, -1, "M", style=wx.CHK_2STATE)
        if (mainmut & 0x01) == 0:
            self.mtlbtn.SetValue(0)
        else:
            self.mtlbtn.SetValue(1)
        self.Bind(wx.EVT_CHECKBOX, self.mainMuteL, self.mtlbtn)
        mvLlbl = wx.StaticText(self, -1, "- L -")
        mvLlbl.SetFont(wx.Font(11, wx.DEFAULT, wx.NORMAL, wx.BOLD))
        mvLbox = wx.BoxSizer(wx.VERTICAL)
        mvLbox.Add(self.mvL,    0, wx.ALL|wx.ALIGN_CENTER, 0)
        mvLbox.Add(self.mtlbtn, 0, wx.ALL|wx.ALIGN_CENTER, 0)
        mvLbox.Add(mvLlbl,      0, wx.ALL|wx.ALIGN_CENTER, 0)

        #### $B%a%$%s%\%j%e!<%`(BR ####
        v = 127 - mndata.getmainR()
        self.mvR =wx.Slider(self, -1, v, 0, 127, size=(40, 238),
                       style=wx.SL_VERTICAL | wx.SL_AUTOTICKS | wx.SL_LEFT |
                       wx.SL_RIGHT | wx.ALIGN_CENTER_VERTICAL,
                        name="MainVolumeR")
        self.mvR.SetTickFreq(step)
        self.Bind(wx.EVT_SCROLL, self.mainRSlider, self.mvR)
        self.mtrbtn = wx.CheckBox(self, -1, "M", style=wx.CHK_2STATE)
        if (mainmut & 0x10) == 0:
            self.mtrbtn.SetValue(0)
        else:
            self.mtrbtn.SetValue(1)
        self.Bind(wx.EVT_CHECKBOX, self.mainMuteR, self.mtrbtn)
        mvRlbl = wx.StaticText(self, -1, "- R -")
        mvRlbl.SetFont(wx.Font(11, wx.DEFAULT, wx.NORMAL, wx.BOLD))
        mvRbox = wx.BoxSizer(wx.VERTICAL)
        mvRbox.Add(self.mvR,    0, wx.ALL|wx.ALIGN_CENTER, 0)
        mvRbox.Add(self.mtrbtn, 0, wx.ALL|wx.ALIGN_CENTER, 0)
        mvRbox.Add(mvRlbl,      0, wx.ALL|wx.ALIGN_CENTER, 0)

        #### $B%X%C%I%U%)%s%\%j%e!<%`(B ####
        pdummy = wx.Panel(self, size=(5, 120))
        v = 127-mndata.getphoneL()
        self.pvl = wx.Slider(self, -1, v, 0, 127, size=(35, 120),
                       style=wx.SL_VERTICAL | wx.SL_AUTOTICKS | wx.SL_LEFT,
                       name="phone")
        self.pvl.SetTickFreq(step)
        self.Bind(wx.EVT_SCROLL, self.phoneSlider, self.pvl)
        pvlabel = wx.StaticText(self, -1, "phone")
        pvlabel.SetFont(wx.Font(9, wx.DEFAULT, wx.NORMAL, wx.NORMAL))
        pbox = wx.BoxSizer(wx.VERTICAL)
        pbox.Add(pdummy, 0, wx.ALL, 0)
        pbox.Add(self.pvl, 0, wx.ALL, 0)
        pbox.Add(pvlabel, 0, wx.ALL, 0)

        #### $B%9%i%$%@!<It$N%l%$%"%&%H(B ####
        mvlsizer = wx.BoxSizer(wx.HORIZONTAL)
        mvlsizer.Add(mkbox,  0, wx.ALL, 0)
        mvlsizer.Add(mvLbox, 0, wx.ALL, 0)
        mvlsizer.Add(mvRbox, 0, wx.ALL, 0)
        mvlsizer.Add(pbox,   0, wx.ALL, 0)

        #### $B%;%Q%l!<%?(B ####
        sline = wx.StaticLine(self, -1, size=(120,2), style=wx.LI_HORIZONTAL)

        #### marker, sync, fade in, fade out ####
        self.mkbtn = wx.Button(self, -1, "Mark", size=(60,19))
        self.Bind(wx.EVT_BUTTON, self.setMarkValue, self.mkbtn)
        self.mvbtn = wx.CheckBox(self, -1, "Sync", style=wx.CHK_2STATE)
        self.mvbtn.SetValue(True)
        fibtn = wx.Button(self, -1, "FadeIN", size=(60,19))
        fobtn = wx.Button(self, -1, "FadeOUT", size=(60,19))
        mckbox = wx.GridBagSizer(2, 2)
        mckbox.Add(self.mkbtn, (0, 0))
        mckbox.Add(self.mvbtn, (0, 1), flag=wx.ALIGN_CENTER)
        mckbox.Add(fibtn, (1, 0))
        mckbox.Add(fobtn, (1, 1))

        mvlwin = wx.BoxSizer(wx.VERTICAL)
        mvlwin.Add(mvlsizer, 0, wx.ALL, 0)
        mvlwin.Add(sline, 0, wx.ALL|wx.ALIGN_CENTER, 6)
        mvlwin.Add(mckbox, 0, wx.ALL|wx.ALIGN_CENTER, 4)
        self.SetSizer(mvlwin)
        self.SetAutoLayout(True)
        mvlwin.Fit(self)

    def mainLSlider(self, evt):
        """main volume L Slider process."""
        vm = []
        psrc = []
        psrc.append(127 - self.pvl.GetValue())
        psrc.append(127 - self.pvl.GetValue())
        sl = mndata.getmainL()
        vm.append(127-self.mvL.GetValue())
        vm.append(127-self.mvR.GetValue())
        sub = sl - vm[0]
        if self.mvbtn.GetValue() == True :	# sync check
            vm[1] = vm[1] - sub
            if vm[1] > MAX_MAIN :
                vm[1] = MAX_MAIN
            elif vm[1] < 0 :
                vm[1] = 0
            self.mvR.SetValue(127-vm[1])
            mndata.setMain(3, vm)
            psrc[0] = (psrc[0] * vm[0]) / 127
            psrc[1] = (psrc[1] * vm[1]) / 127
            mndata.setPhone(3, psrc)
        else:
            mndata.setMain(1, vm)
            psrc[0] = (psrc[0] * vm[0]) / 127
            mndata.setPhone(1, psrc)
        mnwin.pgwin.differValue()
        # def mainLSlider end

    def mainRSlider(self, evt):
        """main volume R Slider process."""
        vm = []
        psrc = []
        psrc.append(127 - self.pvl.GetValue())
        psrc.append(127 - self.pvl.GetValue())
        sr = mndata.getmainR()
        vm.append(127-self.mvL.GetValue())
        vm.append(127-self.mvR.GetValue())
        sub = sr - vm[1]
        if self.mvbtn.GetValue() == True :
            vm[0] = vm[0] - sub
            if vm[0] > MAX_MAIN :
                vm[0] = MAX_MAIN
            elif vm[0] < 0 :
                vm[0] = 0
            self.mvL.SetValue(127-mnvl[1])
            mndata.setMain(3, vm)
            psrc[0] = (psrc[0] * vm[0]) / 127
            psrc[1] = (psrc[1] * vm[1]) / 127
            mndata.setPhone(3, psrc)
        else:
            mndata.setMain(2, vm)
            psrc[1] = (psrc[1] * vm[1]) / 127
            mndata.setPhone(2, psrc)
        mnwin.pgwin.differValue()
        # def mainRSlider end

    def mainMuteL(self, evt):
        """main out Mute Check box process"""
        vm = []
        mutel= self.mtlbtn.GetValue()
        sync = self.mvbtn.GetValue()
        flag = 1
        vm.append(0)
        vm.append(0)
        if mutel == True:
            vm[0] = -1
            if sync == True:
                vm[1] = -1
                self.mtrbtn.SetValue(True)
                flag = 3
        else:
            vm[0] = -2
            if sync == True:
                vm[1] = -2
                self.mtrbtn.SetValue(False)
                flag = 3
        mndata.setMain(flag, vm)
        mnwin.pgwin.differValue()

    def mainMuteR(self, evt):
        """main out Mute Check box process"""
        vm = []
        muter= self.mtrbtn.GetValue()
        sync = self.mvbtn.GetValue()
        flag = 1
        vm.append(0)
        vm.append(0)
        if muter == True:
            vm[1] = -1
            if sync == True:
                vm[0] = -1
                self.mtlbtn.SetValue(True)
                flag = 3
        else:
            vm[1] = -2
            if sync == True:
                vm[0] = -2
                self.mtlbtn.SetValue(False)
                flag = 3
        mndata.setMain(flag, vm)
        mnwin.pgwin.differValue()

    def phoneSlider(self, evt):
        """phone volume Slider process."""
        vm = []
        src = 127 - self.pvl.GetValue()
        vm.append((src * (127 - self.mvL.GetValue())) / 127)
        vm.append((src * (127 - self.mvR.GetValue())) / 127)
        mndata.setPhone(3, vm)

    def setMarkValue(self, event):
        vm = []
        vm.append(self.mark.GetValue())
        vm.append(self.mark.GetValue())
        self.mvL.SetValue(vm[0])
        self.mvR.SetValue(vm[1])
        mndata.setMain(3, vm)
        mnwin.pgwin.differValue()

# end of file #
