#----------------------------------------------------------------------
# A very simple wxPython example.  Just a wxFrame, wxPanel,
# wxStaticText, wxButton, and a wxBoxSizer, but it shows the basic
# structure of any wxPython application.
#----------------------------------------------------------------------
import os, sys, string, pprint, copy, time
import serial
import wx
from wxPython.wx import *
from wxPython.help import *
from wxPython.lib.anchors import LayoutAnchors
from wxPython.stc import *

########################################################################
#    $B%W%m%0%i%`@_Dj!&I=<(%Q%M%k(B                                        #
########################################################################
class pgmSettingPanel(wx.Panel):
    def __init__(self, parent, mixcore, mwin, chwin):
        global comctrl
        global pgmnum
        global mndata
        global mainwin
        global chwindow

        pgmnum = 0
        comctrl = mixcore
        mndata = mwin
        mainwin = parent
        chwindow = chwin
        wx.Panel.__init__(self, parent, -1,
                          style=wx.RAISED_BORDER)
        pgmctrl = self

        #### $BHV9fI=<(!&D>@\F~NO(B ####
        self.notle = wx.StaticText(self, -1, " No. ")
        self.notle.SetFont(wx.Font(16, wx.SWISS, wx.NORMAL, wx.NORMAL))
        self.txtno = wx.SpinCtrl(self, -1, "", size=(80,35))
        self.txtno.SetFont(wx.Font(16, wx.SWISS, wx.NORMAL, wx.BOLD))
        self.txtno.SetForegroundColour("blue")
        self.txtno.SetBackgroundColour("white")
        self.txtno.SetRange(0, 200)
        num = mndata.getPgmNum()
        self.txtno.SetValue(num)
        self.Bind(wx.EVT_SPINCTRL , self.incdecNum, self.txtno)

        txtbox = wx.BoxSizer(wx.HORIZONTAL)
        txtbox.Add(self.notle, 0, flag=wx.LEFT | wx.ALIGN_CENTER, border=4)
        txtbox.Add(self.txtno, 0, flag=wx.RIGHT | wx.ALIGN_CENTER, border=4)

        #### PGM$BL>A0F~NO(B ####
        if num != 0:
            name = mndata.getPgmName()
            d = mndata.getPgmDate()
            dstr = 'Date : %2d/%2d/%2d %02d:%02d:%02d'%(d[0],d[1],d[2],d[3],d[4],d[5])
        else:
            name = ""
            dstr = 'Date:'
        self.pgname  = wx.TextCtrl(self, -1, name, size=(160, 20),
                                   style=wx.TE_RIGHT, name="pgname")
        self.pgname.SetFont(wx.Font(10, wx.SWISS, wx.NORMAL, wx.BOLD))
        self.pgname.SetBackgroundColour("white")
        self.pgdate = wx.StaticText(self, -1, dstr)
        self.pgdate.SetFont(wx.Font(10, wx.SWISS, wx.NORMAL, wx.NORMAL))

        #### Load/Save/open/Write ####
        self.load = wx.Button(self, -1, "Load",  size=(40, 20))
        self.writ = wx.Button(self, -1, "Write",  size=(40, 20))
        self.open = wx.Button(self, -1, "Open",  size=(40, 20))
        self.save = wx.Button(self, -1, "Save", size=(40, 20))
        lsbox = wx.BoxSizer(wx.HORIZONTAL)
        lsbox.Add(self.load, 0, flag=wx.LEFT|wx.ALIGN_CENTER, border=2)
        lsbox.Add(self.writ, 0, flag=wx.ALL|wx.ALIGN_CENTER, border=0)
        lsbox.Add(self.open, 0, flag=wx.ALL|wx.ALIGN_CENTER, border=0)
        lsbox.Add(self.save, 0, flag=wx.RIGHT|wx.ALIGN_CENTER, border=2)
        self.Bind(wx.EVT_BUTTON, self.pgmLoad, self.load)
        self.Bind(wx.EVT_BUTTON, self.pgmWrit, self.writ)
        self.Bind(wx.EVT_BUTTON, self.pgmOpen, self.open)
        self.Bind(wx.EVT_BUTTON, self.pgmSave, self.save)

        #### $B%?%$%H%k$H%;%Q%l!<%?(B ####
        pgmtxt = wx.StaticText(self, -1, "Program No.")
        pgmtxt.SetFont(wx.Font(14, wx.DEFAULT, wx.NORMAL, wx.BOLD))
        pgmtxt.SetForegroundColour("blue")
        pgline = wx.StaticLine(self,-1, size=(160,2), style=wx.LI_HORIZONTAL)

        pgmbox = wx.BoxSizer(wx.VERTICAL)
        pgmbox.Add(pgmtxt, 0, flag=wx.TOP|wx.LEFT, border=4)
        pgmbox.Add(txtbox, 0, flag=wx.TOP|wx.ALIGN_CENTER, border=4)
        pgmbox.Add(self.pgname, flag=wx.TOP|wx.ALIGN_CENTER, border=4)
        pgmbox.Add(self.pgdate, flag=wx.LEFT, border=4)
        pgmbox.Add(pgline, 0, flag=wx.TOP|wx.ALIGN_CENTER, border=4)
        pgmbox.Add(lsbox,  0, flag=wx.TOP|wx.ALIGN_CENTER, border=4)

        #### $B%Q%M%k%m%C%/(B ####
        self.chlock = wx.CheckBox(self, -1, "Ch Lock")
        v = mndata.getChLock()
        self.chlock.SetValue(v)
        self.mnlock = wx.CheckBox(self, -1, "Main Lock")
        v = mndata.getMnLock()
        self.mnlock.SetValue(v)
        lkbxstr = wx.StaticBox(self, -1, "Panel Lock")
        lkbox = wx.StaticBoxSizer(lkbxstr, wx.VERTICAL)
        lkbox.Add(self.chlock, 0, wx.ALL, 8)
        lkbox.Add(self.mnlock, 0, wx.ALL, 8)
        self.Bind(wx.EVT_CHECKBOX, self.chPanelLock, self.chlock)
        self.Bind(wx.EVT_CHECKBOX, self.mnPanelLock, self.mnlock)

        str = 'connect'
        col = '#008000'
        nstr = 'noconnect'
        ncol = 'gray'
        self.connect = wx.StaticText(self, -1, nstr)
        self.connect.SetFont(wx.Font(12, wx.DEFAULT, wx.NORMAL, wx.BOLD))
        self.connect.SetForegroundColour(ncol)
        lkcbox = wx.BoxSizer(wx.VERTICAL)
        lkcbox.Add(lkbox, 0, wx.TOP, 36)
        lkcbox.Add(self.connect, 0, wx.ALL, 8)
        comctrl.setConWin(self, str, nstr, col, ncol)

        mnbox = wx.BoxSizer(wx.HORIZONTAL)
        mnbox.Add(pgmbox, 0, wx.ALL, 0)
        mnbox.Add(lkcbox, 0, wx.LEFT|wx.ALIGN_CENTER, 8)
        self.SetSizer(mnbox)
        self.SetAutoLayout(True)
        mnbox.Fit(self)
        self.winsize = self.GetSize()
        for i in range(16):
            chwindow[i].setPgmWin(self)

    def incdecNum(self, evt):
        self.load.SetForegroundColour("blue")
        self.open.SetForegroundColour("blue")

    def differValue(self):
        self.writ.SetForegroundColour("blue")
        self.save.SetForegroundColour("blue")

    def chPanelLock(self, event):
        comctrl.chLock()

    def mnPanelLock(self, event):
        comctrl.mnLock()

    def pgmLoad(self, evt):
        pno = self.txtno.GetValue()
        rtn = mndata.setPgmLoad(pno)
        if rtn == False:
            str = "Program No.%d is not saved!!"%pno
            dlg = wx.MessageDialog(self, str, "Error", wx.OK|wx.ICON_ERROR)
            dlg.ShowModal()
            dlg.Destroy()
            return False
        self.load.SetForegroundColour("black")
        self.open.SetForegroundColour("black")
        self.writ.SetForegroundColour("black")
        self.save.SetForegroundColour("black")
        name = mndata.getPgmName()
        self.pgname.SetValue(name)
        d = mndata.getPgmDate()
        dstr = 'Date : %2d/%2d/%2d %02d:%02d:%02d'%(d[0],d[1],d[2],d[3],d[4],d[5])
        self.pgdate.SetLabel(dstr)        
        mainwin.updateAll()
        for i in range(16):
            chwindow[i].updateAll()

    def pgmWrit(self, evt):
        date = []
        pno = self.txtno.GetValue()
        if pno == 0:
            dlg = wx.MessageDialog(self, "Program No.0 cannot use!    ",
                                   "Error", wx.OK|wx.ICON_ERROR)
            dlg.ShowModal()
            dlg.Destroy()
            return False
        pname = self.pgname.GetValue()
        if pname == "":
            dlg = wx.MessageDialog(self, "Program name is none!    ",
                                   "Error", wx.OK|wx.ICON_ERROR)
            dlg.ShowModal()
            dlg.Destroy()
            return False
        (y, m, d, H, M, S, w, Day, Dst) = time.localtime(time.time())
        date.append(y-2000)
        date.append(m)
        date.append(d)
        date.append(w)
        date.append(H)
        date.append(M)
        date.append(S)
        mndata.setPgmSave(pno, pname, date)
        self.load.SetForegroundColour("black")
        self.open.SetForegroundColour("black")
        self.writ.SetForegroundColour("black")
        self.save.SetForegroundColour("black")

    def pgmOpen(self, evt):
        wildcard = "Mixer Setting(*.mix)|*.mix|" "All files(*.*)|*.*"
        dlg = wx.FileDialog(
              self, message="Open a mixer file", defaultDir=os.getcwd(),
              defaultFile="", wildcard=wildcard, style=wx.OPEN | wx.CHANGE_DIR
              )
        if dlg.ShowModal() == wx.ID_OK:
            path = dlg.GetPath()
            print "open %s"%path
        dlg.Destroy()

    def pgmSave(self, evt):
        wildcard = "Mixer Setting(*.mix)|*.mix|" "All files(*.*)|*.*"
        pno = self.txtno.GetValue()
        dlg = wx.FileDialog(
              self, message="Save mixer file as...", defaultDir=os.getcwd(),
              defaultFile="", wildcard=wildcard, style=wx.SAVE | wx.CHANGE_DIR
              )
        dlg.SetFilterIndex(2)
        if dlg.ShowModal() == wx.ID_OK:
            path = dlg.GetPath()
            print "file saved as %s"%path
        dlg.Destroy()
        if pno < 100:
            print "Program to Mixer"
            sefl.pgmWrit()

# end of file #
