import os, sys, string, pprint, copy
import serial
import wx
from pgwin import *
from wxPython.wx import *
from wxPython.help import *
from wxPython.lib.anchors import LayoutAnchors
from wxPython.stc import *

class mixSysEnv(wx.Dialog):
    def __init__(self, parent, ID, sysctrl, size=wx.DefaultSize,
                 pos=wx.DefaultPosition, style=wx.DEFAULT_DIALOG_STYLE):
        global curDir
        curDir = os.getcwd()
        title = "Mixer System Settings."
        pre = wx.PreDialog()
        #pre.SetExtraStyle(wx.DIALOG_EX_CONTEXTHELP)
        pre.Create(parent, ID, title, pos, size, style)
        self.this = pre.this
        self.sysctrl = sysctrl
        self.comwin = []

        #### Serial port settings ####
        comTitle = wx.StaticBox(self, -1, "Communication Settings")
        comTitle.SetFont(wx.Font(10, wx.MODERN, wx.NORMAL, wx.BOLD))
        com = wx.StaticBoxSizer(comTitle, wx.VERTICAL)
        comw = comPanel(self, sysctrl,
                        "---- Host Communication setting ----", 0)
        self.comwin.append(comw)
        comw = comPanel(self, sysctrl,
                        "---- Cascade Communication setting ----", 1)
        self.comwin.append(comw)
        comw = comPanel(self, sysctrl,
                        "---- MIDI Communication setting ----", 2)
        self.comwin.append(comw)
        comw = comPanel(self, sysctrl,
                        "---- Console Communication setting ----", 3)
        self.comwin.append(comw)
        for i in range(4):
            com.Add(self.comwin[i], 0, wx.ALIGN_CENTRE|wx.ALL, 4)

        #### Beep/contrast/startmode settinngs ####
        sysTitle = wx.StaticBox(self, -1, "Misc Settings")
        sysTitle.SetFont(wx.Font(10, wx.MODERN, wx.NORMAL, wx.BOLD))
        sysenv = wx.StaticBoxSizer(sysTitle, wx.VERTICAL)
        self.beep = beepPanel(self, sysctrl)
        self.lcd  = contrastPanel(self, sysctrl)
        self.smod = startmodePanel(self, sysctrl)
        sysenv.Add(self.beep, 0, wx.ALIGN_CENTRE|wx.ALL, 4)
        sysenv.Add(self.lcd,  0, wx.ALIGN_CENTRE|wx.ALL, 4)
        sysenv.Add(self.smod, 0, wx.ALIGN_CENTRE|wx.ALL, 4)

        #### OK/Cacel button ####
        box = wx.BoxSizer(wx.HORIZONTAL)
        btn = wx.Button(self, wx.ID_OK, " OK ")
        btn.SetDefault()
        self.Bind(wx.EVT_BUTTON, self.setSysEnv, btn)
        box.Add(btn, 0, wx.ALIGN_CENTRE|wx.ALL, 10)
        btn = wx.Button(self, wx.ID_CANCEL, " Cancel ")
        box.Add(btn, 0, wx.ALIGN_CENTRE|wx.ALL, 10)
        self.Bind(wx.EVT_BUTTON, self.cancelSysEnv, btn)
        wx.ID_TEST = 900
        btn = wx.Button(self, wx.ID_TEST, " BeepTest ")
        box.Add(btn, 0, wx.ALIGN_CENTRE|wx.ALL, 10)
        self.Bind(wx.EVT_BUTTON, self.beepTest, btn)

        sizer = wx.BoxSizer(wx.VERTICAL)
        sizer.Add(com, 0, wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)
        sizer.Add(sysenv, 0, wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)
        sizer.Add(box, 0, wx.ALIGN_CENTER|wx.ALL, 5)

        self.SetSizer(sizer)
        self.SetAutoLayout(True)
        sizer.Fit(self)

    def setSysEnv(self, event):
        for i in range(4):
            self.comwin[i].bpsChoice(0)
            self.comwin[i].stopChoice(0)
            self.comwin[i].lenChoice(0)
            self.comwin[i].parityChoice(0)
        self.beep.beepFreq(0)
        self.beep.beepLength(0)
        self.beep.beepEn(0)
        self.lcd.setContrast(0)
        self.smod.setStartMode(0)
        self.sysctrl.progSysEnv(1)
        self.Destroy()

    def cancelSysEnv(self, event):
        self.sysctrl.progSysEnv(0)
        self.Destroy()

    def beepTest(self, event):
        bf = self.beep.bpfreq.GetValue()
        bl = string.atoi(self.beep.bplen.GetValue())
        str= self.beep.bpen.GetValue()
        if str == 'On':    be = 1
        else:              be = 0
        self.sysctrl.beepTest(bf, bl, be)

########################################################################
#    serial setting
########################################################################
class	comPanel(wx.Panel):
    def __init__(self, parent, sysctrl, title, comnum):
        global comsize
        
        self.cnum = comnum
        self.sysctrl = sysctrl
        comdata = self.sysctrl.getComData(self.cnum)
        wx.Panel.__init__(self, parent, -1, style=wx.NO_BORDER)
        bpss = [9600, 19200, 31250, 38400, 57600, 62500, 100000, 125000,
                250000]
        ptys = ['None', 'Odd', 'Even']
        stps = [1, 2]
        lens = [7, 8]

        title=wx.StaticText(self, -1, title)
        title.SetFont(wx.Font(10, wx.SWISS, wx.NORMAL, wx.NORMAL))
        str = "%d"%sysctrl.getBps(comnum)
        self.bpst= wx.StaticText(self, -1, "Bps:")
        self.bps = wx.ComboBox(self, -1, str,
                               choices=bpss, style=wx.CB_DROPDOWN)
        #self.Bind(wx.EVT_COMBOBOX, self.bpsChoice, self.bps)
        str = "%d"%sysctrl.getStop(comnum)
        self.stpt= wx.StaticText(self, -1, "Stop:")
        self.stp = wx.ComboBox(self, -1, str,
                               choices=stps, style=wx.CB_DROPDOWN)
        #self.Bind(wx.EVT_COMBOBOX, self.stopChoice, self.stp)
        str = "%d"%sysctrl.getDatalen(comnum)
        self.lent= wx.StaticText(self, -1, "Len:")
        self.len = wx.ComboBox(self, -1, str,
                               choices=lens, style=wx.CB_DROPDOWN)
        #self.Bind(wx.EVT_COMBOBOX, self.lenChoice, self.len)
        str = "%s"%ptys[sysctrl.getParity(comnum)]
        self.ptyt= wx.StaticText(self, -1, "Parity:")
        self.pty = wx.ComboBox(self, -1, str,
                               choices=ptys, style=wx.CB_DROPDOWN)
        #self.Bind(wx.EVT_COMBOBOX, self.parityChoice, self.pty)

        sizer = wx.GridBagSizer(2, 8)
        sizer.Add(title, (0,0), span=(1, 8), flag=wx.LEFT, border=4)
        sizer.Add(self.bpst, (1, 0), flag=wx.LEFT|wx.ALIGN_CENTRE, border=4)
        sizer.Add(self.bps,  (1, 1), flag=wx.LEFT|wx.ALIGN_CENTRE, border=0)
        sizer.Add(self.stpt, (1, 2), flag=wx.LEFT|wx.ALIGN_CENTRE, border=4)
        sizer.Add(self.stp,  (1, 3), flag=wx.LEFT|wx.ALIGN_CENTRE, border=0)
        sizer.Add(self.lent, (1, 4), flag=wx.LEFT|wx.ALIGN_CENTRE, border=4)
        sizer.Add(self.len,  (1, 5), flag=wx.LEFT|wx.ALIGN_CENTRE, border=0)
        sizer.Add(self.ptyt, (1, 6), flag=wx.LEFT|wx.ALIGN_CENTRE, border=4)
        sizer.Add(self.pty,  (1, 7),
                  flag=wx.LEFT|wx.RIGHT|wx.ALIGN_CENTRE, border=2)

        self.SetSizer(sizer)
        self.SetAutoLayout(True)
        sizer.Fit(self)
        comsize=self.GetSize()

    def bpsChoice(self, event):
        bps = string.atoi(self.bps.GetValue())
        self.sysctrl.setBps(bps, self.cnum)

    def stopChoice(self, event):
        stop = string.atoi(self.stp.GetValue())
        self.sysctrl.setStop(stop, self.cnum)

    def lenChoice(self, event):
        len = string.atoi(self.len.GetValue())
        self.sysctrl.setDatalen(len, self.cnum)

    def parityChoice(self, event):
        str = self.pty.GetValue()
        if str == 'None':    parity = 0
        elif str == 'Odd':   parity = 1
        else:                parity = 2
        self.sysctrl.setParity(parity, self.cnum)

########################################################################
#    Beep setting
########################################################################
class	beepPanel(wx.Panel):
    def __init__(self, parent, sysctrl):
        global comsize

        self.sysctrl = sysctrl
        wx.Panel.__init__(self, parent, -1, style=wx.NO_BORDER)
        bfeq = [500, 1000, 2000, 3000, 4000, 5000, 6000, 7000, 8000, 9000]
        blen = [8, 16, 32, 64, 128, 256, 512, 1024, 2048]
        ben  = ['On', 'Off']

        title=wx.StaticText(self, -1,   "Beep Setting :")
        title.SetFont(wx.Font(9, wx.MODERN, wx.NORMAL, wx.NORMAL))
        f = sysctrl.getBeepFreq()
        self.bpfreqt = wx.StaticText(self, -1, "Freq:")
        self.bpfreq  = wx.SpinCtrl(self, -1, "", size=(50,20))
        self.bpfreq.SetRange(100, 9000)
        self.bpfreq.SetValue(f)
        self.bpfrequ = wx.StaticText(self, -1, "Hz")
        self.Bind(wx.EVT_SPIN_UP, self.beepUP, self.bpfreq)
        self.Bind(wx.EVT_SPIN_DOWN, self.beepDOWN, self.bpfreq)

        str = "%d"%sysctrl.getBeepLen()
        self.bplent = wx.StaticText(self, -1, "Len:")
        self.bplen  = wx.ComboBox(self, -1, str,
                                  choices=blen, style=wx.CB_DROPDOWN)
        self.Bind(wx.EVT_CHOICE, self.beepLength, self.bplen)
        self.bplenu = wx.StaticText(self, -1, "msec")

        f = sysctrl.getBeepEn()
        if f == 1:    str = 'On'
        else:         str = 'Off'
        self.bpen = wx.ComboBox(self, -1, str,
                                  choices=ben, style=wx.CB_DROPDOWN)

        sizer =wx.BoxSizer(wx.HORIZONTAL)
        sizer.Add(title, 0, wx.ALIGN_CENTRE|wx.LEFT|wx.RIGHT, 8)
        sizer.Add(self.bpfreqt, 0, wx.LEFT|wx.ALIGN_CENTRE, 8)
        sizer.Add(self.bpfreq,  0, wx.LEFT|wx.ALIGN_CENTRE, 0)
        sizer.Add(self.bpfrequ, 0, wx.LEFT|wx.ALIGN_CENTRE, 0)
        sizer.Add(self.bplent,  0, wx.LEFT|wx.ALIGN_CENTRE, 4)
        sizer.Add(self.bplen,   0, wx.LEFT|wx.ALIGN_CENTRE, 0)
        sizer.Add(self.bplenu,  0, wx.LEFT|wx.ALIGN_CENTRE, 4)
        sizer.Add(self.bpen,    0, wx.LEFT|wx.RIGHT|wx.ALIGN_CENTRE, 4)

        self.SetSizer(sizer)
        self.SetAutoLayout(True)
        sizer.Fit(self)
        size = self.GetSize()
        bpsize = (comsize.width, size.height)
        self.SetSize(bpsize)

    def beepUP(self, event):
        now = self.bpfreq.GetValue() / 100
        next = now + 1
        if next > 90:  next = 90
        self.bpfreq.SetValue((next*100)-1)

    def beepDOWN(self, event):
        now = self.bpfreq.GetValue() / 100
        next = now - 1
        if now < 1:  next = 1
        self.bpfreq.SetValue((next*100)+1)

    def beepFreq(self, event):
        f = self.bpfreq.GetValue()
        self.sysctrl.setBeepFreq(f)

    def beepLength(self, event):
        l = string.atoi(self.bplen.GetValue())
        self.sysctrl.setBeepLen(l)

    def beepEn(self, event):
        str = self.bpen.GetValue()
        if str == 'On':    e = 1
        else:              e = 0

########################################################################
#    Contrast setting
########################################################################
class	contrastPanel(wx.Panel):
    def __init__(self, parent, sysctrl):
        global comsize

        self.sysctrl = sysctrl
        wx.Panel.__init__(self, parent, -1, style=wx.NO_BORDER)

        v = sysctrl.getContrast()
        title = wx.StaticText(self, -1, "LCD Contrast :")
        title.SetFont(wx.Font(9, wx.MODERN, wx.NORMAL, wx.NORMAL))
        self.ctrst = wx.SpinCtrl(self, -1, "", size=(50, 20))
        self.ctrst.SetRange(1, 30)
        self.ctrst.SetValue(v)
        self.Bind(wx.EVT_SPINCTRL , self.testContrast, self.ctrst)

        sizer = wx.BoxSizer(wx.HORIZONTAL)
        sizer.Add(title, 0, wx.ALIGN_CENTRE|wx.LEFT|wx.RIGHT, 8)
        sizer.Add(self.ctrst, 0, wx.LEFT|wx.ALIGN_CENTRE, 8)

        self.SetSizer(sizer)
        self.SetAutoLayout(True)
        sizer.Fit(self)
        size = self.GetSize()
        ctsize = (comsize.width, size.height)
        self.SetSize(ctsize)

    def testContrast(self, event):
        c = self.ctrst.GetValue()
        self.sysctrl.testContrast(c)

    def setContrast(self, event):
        c = self.ctrst.GetValue()
        self.sysctrl.setContrast(c)

########################################################################
#    Startmode setting
########################################################################
class	startmodePanel(wx.Panel):
    def __init__(self, parent, sysctrl):
        global comsize

        wx.Panel.__init__(self, parent, -1, style=wx.NO_BORDER)
        mdlist = ["Continue", "Program"]

        self.sysctrl = sysctrl
        v = sysctrl.getStartMode()
        if v == 0: str='Program'
        else:      str='Continue'
        title = wx.StaticText(self, -1, "Start mode   :")
        title.SetFont(wx.Font(9, wx.MODERN, wx.NORMAL, wx.NORMAL))
        self.stmdt = wx.StaticText(self, -1, "mode:")
        self.stmd  = wx.ComboBox(self, -1, str,
                                 choices=mdlist, style=wx.CB_DROPDOWN)

        v = sysctrl.getDefaultCh()
        self.pgmt = wx.StaticText(self, -1, "PGM No.:")
        self.pgm = wx.SpinCtrl(self, -1, "", size=(50, 20))
        self.pgm.SetRange(0, 999)
        self.pgm.SetValue(v)

        sizer =wx.BoxSizer(wx.HORIZONTAL)
        sizer.Add(title, 0, wx.ALIGN_CENTRE|wx.LEFT|wx.RIGHT, 8)
        sizer.Add(self.stmdt, 0, wx.LEFT|wx.ALIGN_CENTRE, 8)
        sizer.Add(self.stmd,  0, wx.LEFT|wx.ALIGN_CENTRE, 0)
        sizer.Add(self.pgmt,  0, wx.LEFT|wx.ALIGN_CENTRE, 20)
        sizer.Add(self.pgm,   0, wx.LEFT|wx.RIGHT|wx.ALIGN_CENTRE, 4)

        self.SetSizer(sizer)
        self.SetAutoLayout(True)
        sizer.Fit(self)
        size = self.GetSize()
        smsize = (comsize.width, size.height)
        self.SetSize(smsize)

    def setStartMode(self, event):
        str = self.stmd.GetValue()
        if str == "Program":    sm = 0
        else:                   sm = 1
        self.sysctrl.setStartMode(sm)
        v = self.pgm.GetValue()
        self.sysctrl.setDefaultCh(v)
